/**
 * AES 128bit 加密解密工具类
 */
package com.bonus.sharedstation.common.utils;

import cn.hutool.core.codec.Base64;
import com.bonus.common.core.web.domain.AjaxResult;

import javax.crypto.Cipher;
import javax.crypto.spec.IvParameterSpec;
import javax.crypto.spec.SecretKeySpec;
import java.nio.charset.StandardCharsets;

/**
 * AesEncryptUtil---加解密
 * @Author zhangzheng
 * @Description
 * @Date 2023/10/18 11:07
 */
public class AesEncryptUtil {

	/**
	 使用AES-128-CBC加密模式，key需要为16位,key和iv可以相同！
	 */
	public static final String KY2 = "greenh5java12345";

	public static final String IV = "greenh5java12345";

	/**
	 * 加密方法
	 * 
	 * @param data
	 *            要加密的数据
	 * @param key
	 *            加密key
	 * @param iv
	 *            加密iv
	 * @return 加密的结果
	 * @throws Exception
	 */
	public static Object encrypt(String data, String key, String iv) {
		if (data == null || data.trim().equals("")) {
			return null;
		}
		try {

			Cipher cipher = Cipher.getInstance("AES/CBC/NoPadding");
			int blockSize = cipher.getBlockSize();

			byte[] dataBytes = data.getBytes();
			int plaintextLength = dataBytes.length;
			if (plaintextLength % blockSize != 0) {
				plaintextLength = plaintextLength + (blockSize - (plaintextLength % blockSize));
			}

			byte[] plaintext = new byte[plaintextLength];
			System.arraycopy(dataBytes, 0, plaintext, 0, dataBytes.length);

			SecretKeySpec keyspec = new SecretKeySpec(key.getBytes(), "AES");
			IvParameterSpec ivspec = new IvParameterSpec(iv.getBytes());

			cipher.init(Cipher.ENCRYPT_MODE, keyspec, ivspec);
			byte[] encrypted = cipher.doFinal(plaintext);
			return Base64.encode(encrypted);
		} catch (Exception e) {
			e.printStackTrace();
			return AjaxResult.error("返回异常");
		}
	}

	/**
	 * 解密方法
	 * 
	 * @param data
	 *            要解密的数据
	 * @param key
	 *            解密key
	 * @param iv
	 *            解密iv
	 * @return 解密的结果
	 * @throws Exception
	 */
	public static Object desEncrypt(String data, String key, String iv) {
		if (data == null || data.trim().equals("")) {
			return null;
		}
		try {
			byte[] b = data.getBytes();
			byte[] encrypted1 = Base64.decode(b);
			Cipher cipher = Cipher.getInstance("AES/CBC/NoPadding");
			SecretKeySpec keyspec = new SecretKeySpec(key.getBytes(), "AES");
			IvParameterSpec ivspec = new IvParameterSpec(iv.getBytes());

			cipher.init(Cipher.DECRYPT_MODE, keyspec, ivspec);

			byte[] original = cipher.doFinal(encrypted1);
			return new String(original, StandardCharsets.UTF_8);
		} catch (Exception e) {
			return AjaxResult.error("返回异常");
		}
	}

	/**
	 * 使用默认的key和iv加密
	 * 
	 * @param data
	 * @return
	 * @throws Exception
	 */
	public static String encrypt(String data) {
		return encrypt(data, KY2, IV).toString();
	}

	/**
	 * 使用默认的key和iv解密
	 * 
	 * @param data
	 * @return
	 * @throws Exception
	 */
	public static String desEncrypt(String data) {
		return desEncrypt(data, KY2, IV).toString();
	}


	/**
	 * App单独使用的解密方法
	 *
	 * @param data
	 *            要解密的数据
	 * @param key
	 *            解密key
	 * @param iv
	 *            解密iv
	 * @return 解密的结果
	 * @throws Exception
	 */
	public static String desEncryptForApp(String data, String key, String iv) throws Exception {
		if (data == null || data.trim().equals("")) {
			return null;
		}
		try {
			byte[] b = data.getBytes();
			byte[] encrypted1 =Base64.decode(b);
			Cipher cipher = Cipher.getInstance("AES/CBC/NoPadding");
			SecretKeySpec keyspec = new SecretKeySpec(key.getBytes(), "AES");
			IvParameterSpec ivspec = new IvParameterSpec(iv.getBytes());

			cipher.init(Cipher.DECRYPT_MODE, keyspec, ivspec);

			byte[] original = cipher.doFinal(encrypted1);
			return new String(original, "UTF-8");
		} catch (Exception e) {

			return null;
		}
	}

}